/* Zadatak 1B:

Svakom stringu $s$ pridru\v{z}ujemo vrijednost (tipa \texttt{double})
funkcijom $f(s) = \sum_{i} \ascii(s[i]) / (i + 2)$,
gdje $\ascii$ oznacava ASCII k\^{o}d znaka $s[i]$,
a suma ide po svim indeksima $i$ za koje je $s[i] \neq \texttt{'\ttb 0'}$.
Niz stringova zadan je poljem pokaziva\v{c}a na stringove (prve znakove).
\begin{itemize}
  \item[(a)]
	Napiite funkciju
	\texttt{int evaluiraj\_i\_promijeni(char ** polje, int n)} koja,
	za ulazni niz stringova \texttt{polje} i duljinu polja \texttt{n},
	ra\v{c}una prosje\v{c}nu vrijednost funkcije $f$ na svim stringovima iz tog polja.
	Za sve stringove $s$, za koje je $f(s)$ \textbf{manje} ili jednako
	od prosjeka, treba izbaciti pripadni pokaziva\v{c} iz polja \texttt{polje}
	(\texttt{polje} ne treba realocirati).
	Tako promijenjeno polje treba sortirati \textbf{silazno} prema
	vrijednosti funkcije $f$, koriste\'{c}i samo zamjene pokaziva\v{c}a.
	Funkcija vraca novu duljinu polja \texttt{polje}.

  \item[(b)]
	Napiite funkciju \texttt{kreiraj} koja prima jedno polje znakova,
	u kojem je spremljen neki (nepoznati) broj stringova, tako da su
	stringovi nanizani jedan za drugim (kao niz znakova), a na kraju niza
	nalazi se string \texttt{"gotovo"}.
	Funkcija treba kreirati (alocirati) pripadno polje \textbf{pokaziva\v{c}a}
	na prvi znak svakog stringa u nizu (bez zavr\v{s}nog stringa \texttt{"gotovo"}).
	Funkcija vra\'{c}a pokaziva\v{c} na prvi element tog polja (ili
	\texttt{NULL}, ako je polje prazno), a kroz varijabilni argument
	treba vratiti broj pokaziva\v{c}a u tom polju (tj.\ broj stringova
	u ulaznom nizu, bez zavr\v{s}nog). Alocirajte to\v{c}no onliko memorije
	koliko treba za spremanje polja pokaziva\v{c}a.
	Dozvoljeno je koristiti \texttt{malloc} i \texttt{realloc}.
\end{itemize}
\textbf{Napomene:} Zabranjeno je koristiti dodatna polja, osim navedenih.
Smijete koristiti biblioteke \texttt{string.h} i \texttt{stdlib.h}.

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

    /* Funkcija f koja stringu pridruzuje broj. */

double f(char *s) {
    int len = strlen(s), i;
    double res = 0.0;
    for (i = 0; i < len; ++i)
        res += (int) s[i] / (double) (i + 2);
    return res;
}

    /* Funkcija evaluiraj_i_promijeni iz (a). */

int evaluiraj_i_promijeni(char ** polje, int n) {
    int i, j, ind_max;
    double prosjek = 0.0, f_max, f_j;
    char *temp;

        /* Test n, za svaki slucaj. */
    if (n == 0) return 0;

        /* Prosjek funkcije f na zadanom polju. */
    for (i = 0; i < n; ++i)
        prosjek += f(polje[i]);
    prosjek = prosjek / n;

        /* Kontrolni ispis - NE treba u rjesenju. */
    printf(" Pocetni n = %d\n", n);
    printf(" Pocetno polje:\n");
    for (i = 0; i < n; ++i)
        printf("   polje[%2d] = %s   f = %lg\n", i, polje[i], f(polje[i]));
    printf(" Prosjek funkcije = %lg\n", prosjek);


        /* Izbaci pokazivace na stringove s iz polja,
           za koje je f(s) <= prosjek. */
        /* Napomena: NE valja  for (i = 0; i < n; ++i) ... */
    i = 0;
    while (i < n)
        if (f(polje[i]) <= prosjek) {

                /* Izbaci polje[i], tj. one iza njega pomakni
                   jedno mjesto naprijed, smanji n. */
            for (j = i + 1; j < n; ++j)
                polje[j - 1] = polje[j];

                /* Smanji n, NEMOJ povecati i!
                   Nema realokacije polja polje. */
            --n;
        }
        else  /* Povecaj i za 1. */
            ++i;

        /* Sortiraj preostale stringove SILAZNO po funkciji f. */
        /* Koristimo sortiranje izborom ekstrema. */

    for (i = 0; i < n - 1; ++i) {
        ind_max = i;
        f_max = f(polje[i]);
        for (j = i + 1; j < n; ++j) {
            f_j = f(polje[j]);
            if (f_j > f_max) {
                ind_max = j;
                f_max = f_j;
            }
        }
        if (i != ind_max) {
            temp = polje[i];
            polje[i] = polje[ind_max];
            polje[ind_max] = temp;
        }
    }

        /* Bubble sort u komentaru. */
/*
    for (i = 0; i < n - 1; ++i)
        for (j = i + 1; j < n; ++j)
            if (f(polje[i]) < f(polje[j])) {
                temp = polje[i];
                polje[i] = polje[j];
                polje[j] = temp;
            }
*/

        /* Kontrolni ispis - NE treba u rjesenju. */
    printf("\n Preostali n = %d\n", n);
    printf(" Sortirano polje:\n");
    for (i = 0; i < n; ++i)
        printf("   polje[%2d] = %s   f = %lg\n", i, polje[i], f(polje[i]));

    return n;
}

    /* Funkcija kreiraj iz (b) - varijanta s jednom alokacijom. */

char ** kreiraj(char *znakovi, int *p_broj) {
    int n = 0;
    char **polje = NULL;

    char zadnja[] = "gotovo";  // Oznaka za kraj.
    int poc = 0;  // Indeks pocetka sljedeceg stringa.
    int i;

        /* Varijanta s jednom alokacijom:
           - prvo prebrojimo stringove do oznake za kraj,
           - zatim (jednom) alociramo polje pokazivaca,
           - prodjemo jos jednom po stringovima i postavimo pokazivace. */

        /* Brojanje stringova u polju znakovi. */
    while (1) {

            /* Test sljedeceg stringa na zadnji = oznaka za kraj.
               Oznaka za kraj nije clan niza, zato break. */
        if (strcmp(&znakovi[poc], zadnja) == 0) break;

            /* Povecaj broj stringova u nizu. */
        ++n;

            /* Makni poc za duljinu ucitanog stringa + 1. */
        poc += strlen(&znakovi[poc]) + 1;
    }

        /* Alokacija za polje i postavljanje pokazivaca. */
    if (n > 0) {

            /* Alokacija za polje pokazivaca na n stringova. */
        polje = (char**) malloc(n * sizeof(char*));

            /* Postavljanje pokazivaca na stringove. */
        poc = 0;
        for (i = 0; i < n; ++i) {

                /* Postavi pokazivac na i-ti string. */
            polje[i] = &znakovi[poc];

                /* Makni poc za duljinu ucitanog stringa + 1. */
            poc += strlen(&znakovi[poc]) + 1;
        }
    }

        /* Vrati varijabilni argument (broj pokazivaca/rijeci)
           i izlaznu vrijednost - pokazivac na polje pokazivaca. */
    *p_broj = n;
    return polje;
}

    /* Funkcija kreiraj iz (b) - varijanta s alokacijom/realokacijom. */

char ** kreiraj_realloc(char *znakovi, int *p_broj) {
    int n = 0;
    char **polje = NULL;

    char zadnja[] = "gotovo";  // Oznaka za kraj.
    int poc = 0;  // Indeks pocetka sljedeceg stringa.

        /* Varijanta s alokacijom/realokacijom:
           - za svaki sljedeci string (do oznake za kraj)
             realociramo polje i postavljamo novi pokazivac. */

        /* Jedan prolaz kroz stringove u polju znakovi. */
    while (1) {

            /* Test sljedeceg stringa na zadnji = oznaka za kraj.
               Oznaka za kraj nije clan niza, zato break. */
        if (strcmp(&znakovi[poc], zadnja) == 0) break;

            /* Povecaj broj stringova u nizu. */
        ++n;

            /* Alociraj/realociraj polje. */
        if (n == 1)
                /* Alokacija za polje pokazivaca na 1 string. */
            polje = (char**) malloc(sizeof(char*));
        else
                /* Realokacija za polje pokazivaca na n stringova. */
            polje = (char**) realloc(polje, n * sizeof(char*));

            /* Postavi pokazivac na n-ti string (indeks je n-1). */
        polje[n - 1] = &znakovi[poc];

            /* Makni poc za duljinu ucitanog stringa + 1. */
        poc += strlen(&znakovi[poc]) + 1;
    }

        /* Vrati varijabilni argument (broj pokazivaca/rijeci)
           i izlaznu vrijednost - pokazivac na polje pokazivaca. */
    *p_broj = n;
    return polje;
}


    /* Glavni program za demostraciju rada funkcija. */

int main(void) {
    char znakovi[100];  // Polje s nanizanim stringovima.
    int poc = 0;        // Indeks pocetka sljedeceg stringa.
    char **polje;
    int broj = 0;

        /* Ucitava stringove (rijeci) odvojene bjelinama
           (scanf, %s format), sve do kraja ulaza. */
        /* Pretpostavljamo da svi stringovi stanu u polje znakovi
           (nema nikakve kontrole).
           Namjerno NE broji stringove i ucitane znakove! */

    while (1) {
            /* Test za kraj ucitavanja = nema sljedeceg stringa. */
        if (scanf("%s", &znakovi[poc]) < 1) break;

            /* Makni poc za duljinu ucitanog stringa + 1. */
        poc += strlen(&znakovi[poc]) + 1;
    }

        /* Pozovi funkciju kreiraj [iz (b)] da napravi
           polje pokazivaca na stringove u polju znakovi. */
    polje = kreiraj(znakovi, &broj);

        /* Pozovi funkciju evaluiraj_i_promijeni [iz (a)]
           za promjenu i sortiranje. */
    broj = evaluiraj_i_promijeni(polje, broj);

    free(polje);

    return 0;
}
