/* Zadatak 2A:

Definirajte tip podataka \texttt{jelo} kao strukturu koja sadr\v{z}i
sljede\'{c}e podatke: string \textit{naziv}, polje stringova \textit{namirnice},
te \textit{duljina} polja i \textit{cijena} kao cjelobrojni tip.
Duljina svih stringova je ograni\v{c}ena na $100$ znakova.
\begin{itemize}
  \item[(a)]
	Napi\v{s}ite funkciju \texttt{kreiraj}, koja alocira strukturu za
	novo jelo, u\v{c}itava sve navedene podatke sa standardnog ulaza,
	i vra\'ca pokaziva\v{c} na alociranu strukturu.
  \item[b)]
	Napi\v{s}ite funkciju \texttt{nutricionist}, koja prima polje jela
	i sa standardnog ulaza u\v{c}itava podatke ``idealnog'' jela.
	Zatim, u polju tra\v{z}i jelo koje ima najvie zajedni\v{c}kih
	namirnica s idealnim jelom. Ako takvih jela ima vi\v{s}e, onda
	se uzima najjeftinije jelo. Ako i takvih ima vi\v{s}e, uzima se
	ono najmanjeg indeksa.
	Na mjesto na\dj enog jela (u polju) treba upisati idealno jelo,
	a staro (ono na\dj eno) treba vratiti kroz varijabilni argument.
	Funkcija vra\'ca $1$ ako staro jelo ima sve sastojke idealnog,
	a $0$ ina\v{c}e.
\end{itemize}
\textbf{Napomene:} Smijete koristiti biblioteke \texttt{string.h} i \texttt{stdlib.h}.

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

    /* Tip podataka. */

typedef struct _jelo {
    char naziv[101];
    char (*namirnice)[101];
    int duljina, cijena;
} jelo;

    /* Funkcija kreiraj (za citanje) iz (a). */

jelo *kreiraj(void)
{
    int i;
    jelo *novo = (jelo*) malloc(sizeof(jelo));

        /* Poredak citanja: prvo fiksne stvari, onda duljina polja
           stringova (za alokaciju), pa polje stringova na kraju. */
    scanf(" %[^\n]", novo->naziv);

        /* Mora adresa cijene. */
    scanf(" %d", &(novo->cijena));

        /* Duljina polja ide PRIJE alokacije polja. */
        /* Mora adresa duljine. */
    scanf(" %d", &(novo->duljina));

        /* Alokacija polja stringova namirnice, zadane duljine. */
    novo->namirnice = (char (*)[101])
                        malloc(novo->duljina * sizeof(char[101]));
        /* Citanje polja stringova, po jedan u redu. */
    for (i = 0; i < novo->duljina; ++i)
        scanf(" %[^\n]", novo->namirnice[i]);

    return novo;
}

    /* Pomocna funkcija za broj zajednickih namirnica
       (presjek skupova) u dva jela.
       Ovdje pretpostavljanmo da su namirnice zaista skupovi,
       tj. da NEMA ponavljanja ISTIH namirnica u nekom jelu. */

int broj_zajednickih(jelo a, jelo b)
{
    int i, j, broj = 0;
    for (i = 0; i < a.duljina; ++i)
        for (j = 0; j < b.duljina; ++j)
            if (strcmp(a.namirnice[i], b.namirnice[j]) == 0)
                ++broj;
    return broj;
}


    /* Funkcija nutricionist iz (b). */

int nutricionist(jelo *polje, int n, jelo *staro)
{
    int i, i_nadjeni, max_zaj, zaj, min_cij, ok;
    jelo *novo = kreiraj();

        /* Inicijalizacija nadjenog na polje[0]. */
    i_nadjeni = 0;
    max_zaj = broj_zajednickih(polje[0], *novo);
    min_cij = polje[0].cijena;

        /* Pretrazivanje po ostatku polja. */
    for (i = 1; i < n; ++i) {

            /* Broj zajednickih za polje[i] i *novo. */
        zaj = broj_zajednickih(polje[i], *novo);

        if (zaj > max_zaj) {
            i_nadjeni = i;
            max_zaj = zaj;
                /* Mora promjena minimalne cijene! */
            min_cij = polje[i].cijena;
        } else if ((zaj == max_zaj) && (polje[i].cijena < min_cij)) {
                /* Test < za cijenu daje minimalni i_nadjeni! */
            i_nadjeni = i;
            min_cij = polje[i].cijena;
        }
    }

        /* Staro je nadjeno, a novo ide u polje na njegovo mjesto. */
    *staro = polje[i_nadjeni];
    polje[i_nadjeni] = *novo;

        /* Izlazna vrijednost funkcije, prije free(novo). */
    ok = max_zaj == novo->duljina;

        /* Oslobodi memoriju za novo, jer je iskopirano.
           Ovo nije nuzno u rjesenju, ali ima smisla. */
    free(novo);

    return ok;
}


    /* Glavni program - prazan. */

int main (void)
{
    return 0;
}
