/* Zadatak 2B:

Definirajte tip podataka \texttt{napitak} kao strukturu koja sadr\v{z}i
sljede\'{c}e podatke: string \textit{ime}, polje stringova \textit{sastojci},
te \textit{duljina} polja i \textit{alkohol} (postotak) kao cjelobrojni tip.
Duljina svih stringova je ograni\v{c}ena na $30$ znakova.
\begin{itemize}
  \item[(a)]
	Napi\v{s}ite funkciju \texttt{kreiraj}, koja alocira strukturu za
	novi napitak, u\v{c}itava sve navedene podatke sa standardnog ulaza,
	i vra\'ca pokaziva\v{c} na alociranu strukturu.
  \item[b)]
	Napi\v{s}ite funkciju \texttt{barmen}, koja prima polje napitaka
	i sa standardnog ulaza u\v{c}itava podatke ``opasnog'' napitka.
	Zatim, u polju tra\v{z}i napitak koje ima najmanje zajedni\v{c}kih
	sastojaka s opasnim napitkom. Ako takvih napitaka ima vi\v{s}e, onda
	se uzima onaj s najmanjim alkoholom. Ako i takvih ima vi\v{s}e, uzima se
	onaj najve\'{c}eg indeksa.
	Na mjesto na\dj enog napitka (u polju) treba upisati opasni napitak,
	a stari (onaj na\dj eni) treba vratiti kroz varijabilni argument.
	Funkcija vra\'ca $1$ ako stari napitak nema niti jedan sastojak opasnog,
	a $0$ ina\v{c}e.
\end{itemize}
\textbf{Napomene:} Smijete koristiti biblioteke \texttt{string.h} i \texttt{stdlib.h}.

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

    /* Tip podataka. */

typedef struct _napitak {
    char ime[31];
    char (*sastojci)[31];
    int duljina, alkohol;
} napitak;

    /* Funkcija kreiraj (za citanje) iz (a). */

napitak *kreiraj(void)
{
    int i;
    napitak *novi = (napitak*) malloc(sizeof(napitak));

        /* Poredak citanja: prvo fiksne stvari, onda duljina polja
           stringova (za alokaciju), pa polje stringova na kraju. */
    scanf(" %[^\n]", novi->ime);

        /* Mora adresa alkohola. */
    scanf(" %d", &(novi->alkohol));

        /* Duljina polja ide PRIJE alokacije polja. */
        /* Mora adresa duljine. */
    scanf(" %d", &(novi->duljina));

        /* Alokacija polja stringova sastojci, zadane duljine. */
    novi->sastojci = (char (*)[31])
                       malloc(novi->duljina * sizeof(char[31]));
        /* Citanje polja stringova, po jedan u redu. */
    for (i = 0; i < novi->duljina; ++i)
        scanf(" %[^\n]", novi->sastojci[i]);

    return novi;
}

    /* Pomocna funkcija za broj zajednickih sastojaka
       (presjek skupova) u dva napitka.
       Ovdje pretpostavljanmo da su sastojci zaista skupovi,
       tj. da NEMA ponavljanja ISTIH sastojaka u nekom napitku. */

int broj_zajednickih(napitak a, napitak b)
{
    int i, j, broj = 0;
    for (i = 0; i < a.duljina; ++i)
        for (j = 0; j < b.duljina; ++j)
            if (strcmp(a.sastojci[i], b.sastojci[j]) == 0)
                ++broj;
    return broj;
}


    /* Funkcija barmen iz (b). */

int barmen(napitak *polje, int n, napitak *stari)
{
    int i, i_nadjeni, min_zaj, zaj, min_alk, ok;
    napitak *novi = kreiraj();

        /* Inicijalizacija nadjenog na polje[0]. */
    i_nadjeni = 0;
    min_zaj = broj_zajednickih(polje[0], *novi);
    min_alk = polje[0].alkohol;

        /* Pretrazivanje po ostatku polja. */
    for (i = 1; i < n; ++i) {

            /* Broj zajednickih za polje[i] i *novi. */
        zaj = broj_zajednickih(polje[i], *novi);

        if (zaj < min_zaj) {
            i_nadjeni = i;
            min_zaj = zaj;
                /* Mora promjena minimalnog alkohola! */
            min_alk = polje[i].alkohol;
        } else if ((zaj == min_zaj) && (polje[i].alkohol <= min_alk)) {
                /* Test <= za alkohol daje maksimalni i_nadjeni! */
            i_nadjeni = i;
            min_alk = polje[i].alkohol;
        }
    }

        /* Stari je nadjeni, a novi ide u polje na njegovo mjesto. */
    *stari = polje[i_nadjeni];
    polje[i_nadjeni] = *novi;

        /* Izlazna vrijednost funkcije. */
    ok = min_zaj == 0;

        /* Oslobodi memoriju za novi, jer je iskopiran.
           Ovo nije nuzno u rjesenju, ali ima smisla. */
    free(novi);

    return ok;
}


    /* Glavni program - prazan. */

int main (void)
{
    return 0;
}
