/* Zadatak 2C:

Definirajte tip podataka \texttt{tura} kao strukturu koja sadr\v{z}i
sljede\'{c}e podatke: string \textit{drzava}, polje stringova \textit{atrakcije},
te \textit{duljina} polja i \textit{trajanje} kao cjelobrojni tip.
Duljina svih stringova je ograni\v{c}ena na $70$ znakova.
\begin{itemize}
  \item[(a)]
	Napi\v{s}ite funkciju \texttt{kreiraj}, koja alocira strukturu za
	novu turu, u\v{c}itava sve navedene podatke sa standardnog ulaza,
	i vra\'ca pokaziva\v{c} na alociranu strukturu.
  \item[b)]
	Napi\v{s}ite funkciju \texttt{vodic}, koja prima polje tura
	i sa standardnog ulaza u\v{c}itava podatke ``idealne'' ture.
	Zatim, u polju tra\v{z}i turu koja ima najvie zajedni\v{c}kih
	atrakcija s idealnom turom. Ako takvih tura ima vi\v{s}e, onda
	se uzima tura najduljeg trajanja. Ako i takvih ima vi\v{s}e, uzima se
	ona najve\'{c}eg indeksa.
	Na mjesto na\dj ene ture (u polju) treba upisati idealnu turu,
	a staru (onu na\dj enu) treba vratiti kroz varijabilni argument.
	Funkcija vra\'ca $1$ ako stara tura ima sve atrakcije idealne,
	a $0$ ina\v{c}e.
\end{itemize}
\textbf{Napomene:} Smijete koristiti biblioteke \texttt{string.h} i \texttt{stdlib.h}.

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

    /* Tip podataka. */

typedef struct _tura {
    char drzava[71];
    char (*atrakcije)[71];
    int duljina, trajanje;
} tura;

    /* Funkcija kreiraj (za citanje) iz (a). */

tura *kreiraj(void)
{
    int i;
    tura *nova = (tura*) malloc(sizeof(tura));

        /* Poredak citanja: prvo fiksne stvari, onda duljina polja
           stringova (za alokaciju), pa polje stringova na kraju. */
    scanf(" %[^\n]", nova->drzava);

        /* Mora adresa trajanja. */
    scanf(" %d", &(nova->trajanje));

        /* Duljina polja ide PRIJE alokacije polja. */
        /* Mora adresa duljine. */
    scanf(" %d", &(nova->duljina));

        /* Alokacija polja stringova atrakcije, zadane duljine. */
    nova->atrakcije = (char (*)[71])
                        malloc(nova->duljina * sizeof(char[71]));
        /* Citanje polja stringova, po jedan u redu. */
    for (i = 0; i < nova->duljina; ++i)
        scanf(" %[^\n]", nova->atrakcije[i]);

    return nova;
}

    /* Pomocna funkcija za broj zajednickih atrakcija
       (presjek skupova) u dvije ture.
       Ovdje pretpostavljanmo da su atrakcije zaista skupovi,
       tj. da NEMA ponavljanja ISTIH atrakcija u nekoj turi. */

int broj_zajednickih(tura a, tura b)
{
    int i, j, broj = 0;
    for (i = 0; i < a.duljina; ++i)
        for (j = 0; j < b.duljina; ++j)
            if (strcmp(a.atrakcije[i], b.atrakcije[j]) == 0)
                ++broj;
    return broj;
}


    /* Funkcija vodic iz (b). */

int vodic(tura *polje, int n, tura *stara)
{
    int i, i_nadjeni, max_zaj, zaj, max_traj, ok;
    tura *nova = kreiraj();

        /* Inicijalizacija nadjenog na polje[0]. */
    i_nadjeni = 0;
    max_zaj = broj_zajednickih(polje[0], *nova);
    max_traj = polje[0].trajanje;

        /* Pretrazivanje po ostatku polja. */
    for (i = 1; i < n; ++i) {

            /* Broj zajednickih za polje[i] i *nova. */
        zaj = broj_zajednickih(polje[i], *nova);

        if (zaj > max_zaj) {
            i_nadjeni = i;
            max_zaj = zaj;
                /* Mora promjena maksimalnog trajanja! */
            max_traj = polje[i].trajanje;
        } else if ((zaj == max_zaj) && (polje[i].trajanje >= max_traj)) {
                /* Test >= za trajanje daje maksimalni i_nadjeni! */
            i_nadjeni = i;
            max_traj = polje[i].trajanje;
        }
    }

        /* Stara je nadjena, a nova ide u polje na njezino mjesto. */
    *stara = polje[i_nadjeni];
    polje[i_nadjeni] = *nova;

        /* Izlazna vrijednost funkcije, prije free(nova). */
    ok = max_zaj == nova->duljina;

        /* Oslobodi memoriju za novu, jer je iskopirana.
           Ovo nije nuzno u rjesenju, ali ima smisla. */
    free(nova);

    return ok;
}


    /* Glavni program - prazan. */

int main (void)
{
    return 0;
}
