/* Zadatak 2D:

Definirajte tip podataka \texttt{pripravak} kao strukturu koja sadr\v{z}i
sljede\'{c}e podatke: string \textit{mjesavina}, polje stringova \textit{trave},
te \textit{duljina} polja i \textit{tezina} kao cjelobrojni tip.
Duljina svih stringova je ograni\v{c}ena na $50$ znakova.
\begin{itemize}
  \item[(a)]
	Napi\v{s}ite funkciju \texttt{kreiraj}, koja alocira strukturu za
	novi pripravak, u\v{c}itava sve navedene podatke sa standardnog ulaza,
	i vra\'ca pokaziva\v{c} na alociranu strukturu.
  \item[b)]
	Napi\v{s}ite funkciju \texttt{travar}, koja prima polje pripravaka
	i sa standardnog ulaza u\v{c}itava podatke ``opasnog'' pripravka.
	Zatim, u polju tra\v{z}i pripravak koji ima najmanje zajedni\v{c}kih
	trava s opasnim pripravkom. Ako takvih pripravaka ima vi\v{s}e, onda
	se uzima pripravak najmanje te\v{z}ine. Ako i takvih ima vi\v{s}e, uzima se
	onaj najmanjeg indeksa.
	Na mjesto na\dj enog pripravka (u polju) treba upisati opasni pripravak,
	a stari (onaj na\dj eni) treba vratiti kroz varijabilni argument.
	Funkcija vra\'ca $1$ ako stari pripravak nema niti jedan sastojak opasnog,
	a $0$ ina\v{c}e.
\end{itemize}
\textbf{Napomene:} Smijete koristiti biblioteke \texttt{string.h} i \texttt{stdlib.h}.

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

    /* Tip podataka. */

typedef struct _pripravak {
    char mjesavina[51];
    char (*trave)[51];
    int duljina, tezina;
} pripravak;

    /* Funkcija kreiraj (za citanje) iz (a). */

pripravak *kreiraj(void)
{
    int i;
    pripravak *novi = (pripravak*) malloc(sizeof(pripravak));

        /* Poredak citanja: prvo fiksne stvari, onda duljina polja
           stringova (za alokaciju), pa polje stringova na kraju. */
    scanf(" %[^\n]", novi->mjesavina);

        /* Mora adresa tezine. */
    scanf(" %d", &(novi->tezina));

        /* Duljina polja ide PRIJE alokacije polja. */
        /* Mora adresa duljine. */
    scanf(" %d", &(novi->duljina));

        /* Alokacija polja stringova trave, zadane duljine. */
    novi->trave = (char (*)[51])
                    malloc(novi->duljina * sizeof(char[51]));
        /* Citanje polja stringova, po jedan u redu. */
    for (i = 0; i < novi->duljina; ++i)
        scanf(" %[^\n]", novi->trave[i]);

    return novi;
}

    /* Pomocna funkcija za broj zajednickih trava
       (presjek skupova) u dva pripravka.
       Ovdje pretpostavljanmo da su trave zaista skupovi,
       tj. da NEMA ponavljanja ISTIH trava u nekom pripravku. */

int broj_zajednickih(pripravak a, pripravak b)
{
    int i, j, broj = 0;
    for (i = 0; i < a.duljina; ++i)
        for (j = 0; j < b.duljina; ++j)
            if (strcmp(a.trave[i], b.trave[j]) == 0)
                ++broj;
    return broj;
}


    /* Funkcija travar iz (b). */

int travar(pripravak *polje, int n, pripravak *stari)
{
    int i, i_nadjeni, min_zaj, zaj, min_tez, ok;
    pripravak *novi = kreiraj();

        /* Inicijalizacija nadjenog na polje[0]. */
    i_nadjeni = 0;
    min_zaj = broj_zajednickih(polje[0], *novi);
    min_tez = polje[0].tezina;

        /* Pretrazivanje po ostatku polja. */
    for (i = 1; i < n; ++i) {

            /* Broj zajednickih za polje[i] i *novi. */
        zaj = broj_zajednickih(polje[i], *novi);

        if (zaj < min_zaj) {
            i_nadjeni = i;
            min_zaj = zaj;
                /* Mora promjena minimalne tezine! */
            min_tez = polje[i].tezina;
        } else if ((zaj == min_zaj) && (polje[i].tezina < min_tez)) {
                /* Test < za tezinu daje minimalni i_nadjeni! */
            i_nadjeni = i;
            min_tez = polje[i].tezina;
        }
    }

        /* Stari je nadjeni, a novi ide u polje na njegovo mjesto. */
    *stari = polje[i_nadjeni];
    polje[i_nadjeni] = *novi;

        /* Izlazna vrijednost funkcije. */
    ok = min_zaj == 0;

        /* Oslobodi memoriju za novi, jer je iskopiran.
           Ovo nije nuzno u rjesenju, ali ima smisla. */
    free(novi);

    return ok;
}


    /* Glavni program - prazan. */

int main (void)
{
    return 0;
}
