/* Zadatak 4A:

U tekstualnoj datoteci \texttt{kaptol.txt} nalazi se niz prirodnih brojeva
manjih od $1000$, odvojenih razmacima. Brojevi predstavljaju autobusne linije,
poput \texttt{106}. Za svaki broj $i$ iz te datoteke, postoji datoteka
\texttt{i.txt} (\texttt{i} je dekadski zapis broja $i$), primjerice
\texttt{106.txt}, u kojoj se nalazi reci sljedeceg oblika:
\begin{displaymath}
	\text{\texttt{sat:minute S}}
\end{displaymath}
Pritom je \texttt{sat} cijeli broj izme\dj u $0$ i $23$ (uklju\v{c}ivo),
\texttt{minute} je cijeli broj izme\dj u $0$ i $59$ (uklju\v{c}ivo),
tako da \texttt{sat:minute} ozna\v{c}ava vrijeme polaska linije,
a \texttt{S} je znak \texttt{'A'} ili \texttt{'B'}, koji ozna\v{c}ava
smjer linije.

Napiite funkciju \texttt{ispis} koja prima dva cijela broja, sat i minute
(u propisanom rasponu), te znak koji oznacava smjer kretanja (\texttt{'A'} ili
\texttt{'B'})\@. Oznacimo vrijeme odredeno ulaznim argumentima funkcije s $t$,
a vrijeme 23:59 \textbf{istoga dana} s $p$.
Potrebno je pronaci \textbf{minimalno} vrijeme $x$, uz $t \leq x \leq p$,
takoder izraeno u obliku \texttt{sat:minute}, takvo da postoji ukupno barem
est polazaka nekih linija unutar vremenskog segmenta
$[x, \min\{p, x + 5 \, {\rm minuta} \}]$
u zadanom smjeru (\texttt{'A'} ili \texttt{'B'}).

Ako takvo vrijeme $x$ postoji, funkcija u datoteku \texttt{izlaz.txt} ispisuje
pronadeno vrijeme $x$ u formatu \texttt{sat:minute}.
Ako je datoteka toga imena vec postojala, prebriite ju.
Ako takvo vrijeme $x$ ne postoji, ne treba ni\v{s}ta pisati.

\vskip 1em \noindent
\textbf{Napomene:} Osim stringova za imena datoteka, \textbf{nije} doputeno
koritenje dodatnih nizova, ali \textbf{moete} proizvoljan broj puta otvarati
i zatvarati datoteke. Moete koristiti zaglavlje \texttt{string.h}. Moete
pretpostaviti da sve potrebne ulazne datoteke postoje, te da su podaci unutar
njih ispravno zapisani. Datoteke nisu nuno sortirane po vremenu polaska i
smjeru, ali unutar pojedine datoteke nema ponavljanja redaka.

*/

#include <stdio.h>
#include <string.h>

void ispis(int sat, int minute, char smjer)
{
        /* Odmah inicijaliziramo f na datoteku brojeva linija.
           Kasnije NE testiramo f == NULL, zbog pretpostavke zadatka. */
    FILE *f = fopen("kaptol.txt", "r");
    int t = sat*60 + minute;    // Pocetno vrijeme (minute).
    int p = 23*60 + 59;         // Zadnje vrijeme prije ponoci = 1439 (minuta).
    int razmak = 5;             // Duljina intervala (max, do na ponoc).
    int vrijeme;                // vrijeme = x iz zadatka.

    int broj_linije;            // Ucitani broj linije iz f.
    int nadjeno;                // Broj nadjenih linija za dano vrijeme (x).

    char ime_linije[8];         // Ime datoteke s brojem linije "nnn.txt".
    FILE *polasci;              // Datoteka s polascima dane linije.
    int h, m, v;                // Sat, minute i vrijeme polaska linije.
    char s;                     // Smjer te linije.

    FILE *izlaz;                // Izlazna datoteka.

        /* Petlja za sva pocetna vremena (vrijeme = x), u minutama. */
    for (vrijeme = t; vrijeme <= p; ++vrijeme) {

            /* Broj nadjenih polazaka u zadanom vremenskom segmentu,
               segment pocinje s vrijeme = x. */
        nadjeno = 0;

            /* Petlja po svim linijama iz datoteke f.
               Prvo postavimo f na pocetak, a zatim ide petlja u kojoj
               citamo sljedeci broj linije, sve dok ga uspjesno ucitamo
               (tj. nismo stigli do kraja datoteke). */
        rewind(f);
        while (fscanf(f, "%d", &broj_linije) == 1) {

                /* Napisemo broj linije (max. 3 znamenke) u string
                   za ime pripadne datoteke i dodamo ".txt". */
            sprintf(ime_linije, "%d.txt", broj_linije);

                /* Otvori pripadnu datoteku s polascima te linije. */
            polasci = fopen(ime_linije, "r");    // Nema kontrole, postoji!

                /* Petlja po svim linijama iz datoteke polasci.
                   U svakoj liniji moraju biti 3 vrijednosti
                   (h = sat, m = minute, s = smjer) u zadanom formatu. */
            while (fscanf(polasci, "%d:%d %c", &h, &m, &s) == 3) {

                    /* Vrijeme polaska linije (u minutama). */
                v = h*60 + m;

                    /* Provjeri smjer s i vrijeme polaska v (je li v
                       u trazenom intervalu). Uociti da je sigurno v <= p
                       (iz formata zapisa), pa ne treba "min". */
                if (s == smjer && vrijeme <= v && v <= vrijeme + razmak)
                    ++nadjeno;
            }

                /* Zatvori datoteku polazaka za danu liniju. */
            fclose(polasci);
        }

            /* Prosli sve linije, vidi koliko smo ih nasli.
               Idemo unaprijed po vremenu, pa PRVI put kad nadjemo
               trazeno vrijeme (za zadani uvjet), dobivamo minimalno!
               Napravimo ispis i prekidamo petlju. */
        if (nadjeno >= 6) {
            izlaz = fopen("izlaz.txt", "w");  // Nema provjere!
            fprintf(izlaz, "%d:%d\n", vrijeme / 60, vrijeme % 60);
            fclose(izlaz);
            break;
        }
    }

        /* Zatvorimo glavnu datoteku f, s brojevima linija. */
    fclose(f);
}

int main(void)
{
  ispis(10, 0, 'A');
  return 0;
}
